-- DROP TABLE IF EXISTS SOLIDDB_ADMIN_COMMANDS;
-- DROP TABLE IF EXISTS SOLIDDB_SYS_BLOBS;
-- DROP TABLE IF EXISTS SOLIDDB_SYS_CARDINAL;
-- DROP TABLE IF EXISTS SOLIDDB_SYS_COLUMNS;
-- DROP TABLE IF EXISTS SOLIDDB_SYS_FORKEYPARTS;
-- DROP TABLE IF EXISTS SOLIDDB_SYS_FORKEYS;
-- DROP TABLE IF EXISTS SOLIDDB_SYS_INFO;
-- DROP TABLE IF EXISTS SOLIDDB_SYS_KEYPARTS;
-- DROP TABLE IF EXISTS SOLIDDB_SYS_KEYS;
-- DROP TABLE IF EXISTS SOLIDDB_SYS_SCHEMAS;
-- DROP TABLE IF EXISTS SOLIDDB_SYS_SEQUENCES;
-- DROP TABLE IF EXISTS SOLIDDB_SYS_TABLEMODES;
-- DROP TABLE IF EXISTS SOLIDDB_SYS_TABLES;

CREATE TABLE SOLIDDB_SYS_TABLES (
	ID              INTEGER NOT NULL,
	TABLE_NAME      VARCHAR(254) UNICODE,
	TABLE_TYPE      VARCHAR(254) UNICODE,
	TABLE_SCHEMA    VARCHAR(254) UNICODE,
	TABLE_CATALOG   VARCHAR(254) UNICODE,
	CREATIME        TIMESTAMP,
	CHECKSTRING     LONG VARCHAR UNICODE,
	REMARKS         LONG VARCHAR UNICODE,
	PRIMARY KEY (ID)
) ENGINE=SOLIDDB;

CREATE TABLE SOLIDDB_SYS_COLUMNS (
	ID                      INTEGER NOT NULL,
	REL_ID                  INTEGER NOT NULL,
	COLUMN_NAME             VARCHAR(254) UNICODE,
	COLUMN_NUMBER           INTEGER NOT NULL,
	DATA_TYPE               VARCHAR(254) UNICODE,
	SQL_DATA_TYPE_NUM       SMALLINT,
	DATA_TYPE_NUMBER        INTEGER,
	CHAR_MAX_LENGTH         INTEGER,
	NUMERIC_PRECISION       INTEGER,
	NUMERIC_PREC_RADIX      SMALLINT,
	NUMERIC_SCALE           SMALLINT,
	NULLABLE                CHAR(3) UNICODE,
	NULLABLE_ODBC           SMALLINT NOT NULL,
	FORMAT                  VARCHAR(254) UNICODE,
	DEFAULT_VAL             VARBINARY(254),
	ATTR_TYPE               INTEGER,
	REMARKS                 LONG VARCHAR UNICODE,
	PRIMARY KEY (REL_ID,COLUMN_NUMBER)
) ENGINE=SOLIDDB;

CREATE TABLE SOLIDDB_SYS_KEYS (
	ID INTEGER NOT NULL,
	REL_ID INTEGER NOT NULL,
	KEY_NAME VARCHAR(254) UNICODE,
	KEY_UNIQUE CHAR(3) UNICODE,
	KEY_NONUNIQUE_ODBC SMALLINT NOT NULL,
	KEY_CLUSTERING CHAR(3) UNICODE NOT NULL,
	KEY_PRIMARY CHAR(3) UNICODE NOT NULL,
	KEY_PREJOINED CHAR(3) UNICODE NOT NULL,
	KEY_SCHEMA VARCHAR(254) UNICODE NOT NULL,
	KEY_NREF INTEGER NOT NULL,
	KEY_CATALOG VARCHAR(254) UNICODE,
	PRIMARY KEY (REL_ID, ID)
) ENGINE=SOLIDDB;

CREATE TABLE SOLIDDB_SYS_KEYPARTS (
	ID INTEGER NOT NULL,
	REL_ID INTEGER NOT NULL,
	KEYP_NO INTEGER NOT NULL,
	ATTR_ID INTEGER,
	ATTR_NO INTEGER,
	ATTR_TYPE INTEGER,
	CONST_VALUE VARBINARY(254),
	ASCENDING CHAR(3) UNICODE NOT NULL,
	PRIMARY KEY (ID,KEYP_NO)
) ENGINE=SOLIDDB;

CREATE TABLE SOLIDDB_SYS_FORKEYS (
	ID INTEGER NOT NULL,
	REF_REL_ID INTEGER NOT NULL,
	CREATE_REL_ID INTEGER NOT NULL,
	REF_KEY_ID INTEGER NOT NULL,
	REF_TYPE INTEGER NOT NULL,
	KEY_SCHEMA VARCHAR(254) UNICODE,
	KEY_CATALOG VARCHAR(254) UNICODE NOT NULL,
	KEY_NREF INTEGER NOT NULL
) ENGINE=SOLIDDB;


CREATE TABLE SOLIDDB_SYS_FORKEYPARTS (
	ID INTEGER NOT NULL,
	KEYP_NO INTEGER NOT NULL,
	ATTR_NO INTEGER NOT NULL,
	ATTR_ID INTEGER NOT NULL,
	ATTR_TYPE INTEGER NOT NULL,
	CONST_VALUE VARBINARY(254)
) ENGINE=SOLIDDB;

CREATE TABLE SOLIDDB_SYS_SCHEMAS (
	ID INTEGER NOT NULL,
	NAME VARCHAR(254) UNICODE NOT NULL,
	OWNER VARCHAR(254) UNICODE NOT NULL,
	CREATIME TIMESTAMP NOT NULL,
	SCHEMA_CATALOG VARCHAR(254) UNICODE,
	PRIMARY KEY (ID)
) ENGINE=SOLIDDB;

CREATE TABLE SOLIDDB_SYS_SEQUENCES (
	SEQUENCE_NAME VARCHAR(254) UNICODE NOT NULL,
	ID INTEGER NOT NULL,
	DENSE VARCHAR(3) UNICODE NOT NULL,
	SEQUENCE_SCHEMA VARCHAR(254) UNICODE NOT NULL,
	SEQUENCE_CATALOG VARCHAR(254) UNICODE NOT NULL,
	CREATIME TIMESTAMP,
	PRIMARY KEY (ID)
) ENGINE = SOLIDDB;

CREATE TABLE SOLIDDB_SYS_BLOBS(
	ID BIGINT NOT NULL,
	STARTPOS BIGINT NOT NULL,
	ENDSIZE  BIGINT NOT NULL,
        TOTALSIZE BIGINT NOT NULL,
	REFCOUNT INTEGER,
	COMPLETE INTEGER,
	STARTCPNUM INTEGER,
	NUMPAGES INTEGER,
	P01_ADDR INTEGER,
	P01_ENDSIZE BIGINT,
	P02_ADDR INTEGER,
	P03_ADDR INTEGER,
	P04_ADDR INTEGER,
	P05_ADDR INTEGER,
	P06_ADDR INTEGER,
	P07_ADDR INTEGER,
	P08_ADDR INTEGER,
	P09_ADDR INTEGER,
	P10_ADDR INTEGER,
	P11_ADDR INTEGER,
	P12_ADDR INTEGER,
	P13_ADDR INTEGER,
	P14_ADDR INTEGER,
	P15_ADDR INTEGER,
	P16_ADDR INTEGER,
	P17_ADDR INTEGER,
	P18_ADDR INTEGER,
	P19_ADDR INTEGER,
	P20_ADDR INTEGER,
	P21_ADDR INTEGER,
	P22_ADDR INTEGER,
	P23_ADDR INTEGER,
	P24_ADDR INTEGER,
	P25_ADDR INTEGER,
	P26_ADDR INTEGER,
	P27_ADDR INTEGER,
	P28_ADDR INTEGER,
	P29_ADDR INTEGER,
	P30_ADDR INTEGER,
	P31_ADDR INTEGER,
	P32_ADDR INTEGER,
	P33_ADDR INTEGER,
	P34_ADDR INTEGER,
	P35_ADDR INTEGER,
	P36_ADDR INTEGER,
	P37_ADDR INTEGER,
	P38_ADDR INTEGER,
	P39_ADDR INTEGER,
	P40_ADDR INTEGER,
	P41_ADDR INTEGER,
	P42_ADDR INTEGER,
	P43_ADDR INTEGER,
	P44_ADDR INTEGER,
	P45_ADDR INTEGER,
	P46_ADDR INTEGER,
	P47_ADDR INTEGER,
	P48_ADDR INTEGER,
	P49_ADDR INTEGER,
	P50_ADDR INTEGER,
	P02_ENDSIZE INTEGER,
	P03_ENDSIZE INTEGER,
	P04_ENDSIZE INTEGER,
	P05_ENDSIZE INTEGER,
	P06_ENDSIZE INTEGER,
	P07_ENDSIZE INTEGER,
	P08_ENDSIZE INTEGER,
	P09_ENDSIZE INTEGER,
	P10_ENDSIZE INTEGER,
	P11_ENDSIZE INTEGER,
	P12_ENDSIZE INTEGER,
	P13_ENDSIZE INTEGER,
	P14_ENDSIZE INTEGER,
	P15_ENDSIZE INTEGER,
	P16_ENDSIZE INTEGER,
	P17_ENDSIZE INTEGER,
	P18_ENDSIZE INTEGER,
	P19_ENDSIZE INTEGER,
	P20_ENDSIZE INTEGER,
	P21_ENDSIZE INTEGER,
	P22_ENDSIZE INTEGER,
	P23_ENDSIZE INTEGER,
	P24_ENDSIZE INTEGER,
	P25_ENDSIZE INTEGER,
	P26_ENDSIZE INTEGER,
	P27_ENDSIZE INTEGER,
	P28_ENDSIZE INTEGER,
	P29_ENDSIZE INTEGER,
	P30_ENDSIZE INTEGER,
	P31_ENDSIZE INTEGER,
	P32_ENDSIZE INTEGER,
	P33_ENDSIZE INTEGER,
	P34_ENDSIZE INTEGER,
	P35_ENDSIZE INTEGER,
	P36_ENDSIZE INTEGER,
	P37_ENDSIZE INTEGER,
	P38_ENDSIZE INTEGER,
	P39_ENDSIZE INTEGER,
	P40_ENDSIZE INTEGER,
	P41_ENDSIZE INTEGER,
	P42_ENDSIZE INTEGER,
	P43_ENDSIZE INTEGER,
	P44_ENDSIZE INTEGER,
	P45_ENDSIZE INTEGER,
	P46_ENDSIZE INTEGER,
	P47_ENDSIZE INTEGER,
	P48_ENDSIZE INTEGER,
	P49_ENDSIZE INTEGER,
	P50_ENDSIZE INTEGER
) ENGINE = SOLIDDB;

CREATE TABLE SOLIDDB_SYS_CARDINAL(
	REL_ID INTEGER NOT NULL,
	CARDIN INTEGER,
	SIZE   INTEGER,
	LAST_UPDATE TIMESTAMP
) ENGINE=SOLIDDB;

CREATE TABLE SOLIDDB_SYS_INFO(
	PROPERTY VARCHAR(254) UNICODE NOT NULL
) ENGINE = SOLIDDB;

CREATE TABLE SOLIDDB_SYS_TABLEMODES(
	ID INTEGER NOT NULL,
	MODE VARCHAR(254) UNICODE,
	MODIFY_TIME TIMESTAMP,
	MODIFY_USER VARCHAR(254) UNICODE
) ENGINE=SOLIDDB;

CREATE TABLE SOLIDDB_ADMIN_COMMANDS (
  COMMAND      VARCHAR(255),
  PARAMETERS   VARCHAR(1024) NULL
) ENGINE=SOLIDDB;

DROP PROCEDURE IF EXISTS soliddb_backup;

DELIMITER ;;

create procedure soliddb_backup ( in backup_dir varchar(2047) )
begin
  insert into mysql.SOLIDDB_ADMIN_COMMANDS ( COMMAND, PARAMETERS )
  values ( 'backup', backup_dir );
end
;;

DELIMITER ;
